package app;

import java.util.Scanner;

public class App {

    public static void main(String[] args) throws Exception {
        Studentenverwaltung verwaltung = new Studentenverwaltung();
        Scanner scanner = new Scanner(System.in);
        String[] inputData = new String[2];
        InputState inputState = InputState.DEFAULT;

        System.out.print("Herzlich Willkommen bei der Studentenverwaltung.\n"
                + "Bitte verwenden Sie:\n list   -> um alle Studenten anzuzeigen\n"
                + " add    -> um einen Studenten hinzuzufügen\n remove -> um einen Studenten zu entfernen\n"
                + " quit   -> um das Progrmam zu beenden\n> ");

        verwaltung.immatrikulieren("Mustermann", "Max", 123456);

        loop: while (scanner.hasNextLine()) {
            String line = scanner.nextLine().toString();
            switch (inputState) {
            case DEFAULT:
                switch (line.toLowerCase()) {
                case "q":
                case "quit":
                    break loop;
                case "list":
                    verwaltung.listeAusgeben();
                    System.out.print("> ");
                    break;
                case "add":
                    inputState = InputState.ADD1;
                    System.out.print("Nachname: ");
                    break;
                case "remove":
                    inputState = InputState.REMOVE;
                    System.out.print("Matrikelnummer: ");
                    break;
                default:
                    System.out.print("Fehler: Kommando exisitert nicht. Bitte versuchen Sie es erneut...\n> ");
                    break;
                }
                break;
            case ADD1:
                inputData[0] = line;
                inputState = InputState.ADD2;
                System.out.print("Vorname: ");
                break;
            case ADD2:
                inputData[1] = line;
                inputState = InputState.ADD3;
                System.out.print("Matrikelnummer: ");
                break;
            case ADD3:
                inputState = InputState.DEFAULT;
                try {
                    verwaltung.immatrikulieren(inputData[0], inputData[1], Integer.parseInt(line));
                    System.out.print("Student wurde erfolgreich immatrikuliert!\n> ");
                } catch (IllegalArgumentException e) {
                    System.out
                            .print("Student konnte nicht immatrikuliert werden. Bitte versuchen Sie es erneut...\n> ");
                }
                break;
            case REMOVE:
                inputState = InputState.DEFAULT;
                try {
                    verwaltung.exmatrikulieren(Integer.parseInt(line));
                    System.out.print("Student wurde erfolgreich exmatrikuliert!\n> ");
                } catch (IllegalArgumentException e) {
                    System.out
                            .print("Student konnte nicht exmatrikuliert werden. Bitte versuchen Sie es erneut...\n> ");
                }
                break;
            }
        }
        scanner.close();
    }
}