package services.dummy;

import model.Pizza;
import services.interfaces.IPizzaService;
import sun.reflect.generics.reflectiveObjects.NotImplementedException;

import java.nio.charset.Charset;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;

public class PizzaServiceDummy implements IPizzaService {
    private Random random = new Random();
    private List<Pizza> pizzas;

    public PizzaServiceDummy() {
        pizzas = getListOfRandomPizzas(20);
    }

    public List<Pizza> getListOfRandomPizzas(int number) {
        List<Pizza> list = new ArrayList<>();
        for (int i = 0; i < number; i++) {
            Pizza p = generateRandomPizza();
            list.add(p);
        }
        return list;
    }

    public Pizza generateRandomPizza() {
        Pizza p = new Pizza();

        int toppingCounter = random.nextInt(10) + 1;
        for (int i = 0; i < toppingCounter; i++) {

            Pizza.Toppings t = getRandomTopping();
            p.addTopping(t);
        }
        p.setSize(getRandomSize());
        p.setName(generateRandomName());

        return p;
    }

    public Pizza.Toppings getRandomTopping() {
        Pizza.Toppings[] toppings = Pizza.Toppings.values();
        int t = random.nextInt(toppings.length - 1);
        return toppings[t];
    }

    public Pizza.Size getRandomSize() {
        Pizza.Size[] sizes = Pizza.Size.values();
        int t = random.nextInt(sizes.length - 1);
        return sizes[t];
    }

    public String generateRandomName() {
        byte[] array = new byte[7]; // length is bounded by 7
        new Random().nextBytes(array);
        return new String(array, Charset.forName("UTF-8"));
    }

    @Override
    public void saveNewPizza(Pizza p) {
        pizzas.add(p);
    }

    @Override
    public List<Pizza> getAllPizzas() {
        return pizzas;
    }

    @Override
    public Pizza getPizzaByNAme(String name) {
        throw new NotImplementedException();
    }
}
